import java.io.*;
import java.util.*;

public class RKdemo2  {
    public RK_resource_set[] arrayOfRS;
    public int num;

    RKdemo2() 
    {
	num = 0;
	arrayOfRS = new RK_resource_set[3];
    }

    void getRS(int id) 
    {
	try {
	    RK_resource_set rs = new RK_resource_set(id);
	    rs.readStatus();
	    arrayOfRS[num++] = rs;
	    System.out.println(num+": ID("+Integer.toHexString(id)+")");
	} catch (Exception e) {
	    System.out.println("Failed to read ID("+Integer.toHexString(id)+")");
	}
    }

    public static void main(String[] args)
    {
	RKdemo2 demo = new RKdemo2();

	Integer zero = new Integer(0);
	for (int i = 0; i < args.length; i++) {
	    System.out.println("arg("+i+"): "+args[i]);

	    int id = (Integer.valueOf(args[i])).intValue();

	    System.out.println("ID("+Integer.toHexString(id)+")");

	    demo.getRS(id);
	}
	RKdemoThread th = new RKdemoThread(demo);
	th.start();
    }
}

class RKdemoThread extends Thread {
    RKdemo2 demo;

    public RKdemoThread(RKdemo2 main) {
	super("RKdemo2");
	demo = main;
    }
    public void run() {
	int i;
	while (true) {
	    for (i = 0; i < demo.num; i++) {
		try {
		    demo.arrayOfRS[i].readStatus();
		    int u = demo.arrayOfRS[i].utilized;
		    System.out.println(i +": util("+ u +")"
				       +"enf_mode("+ demo.arrayOfRS[i].enf_mode +")"
				       +"rep_mode("+ demo.arrayOfRS[i].rep_mode +")");
		} catch (Exception e) {
		}
	    }
	    try {
		sleep(1000);	// milli seconds
	    } catch (InterruptedException e) {}
	}
    }
}

class RK_resource_set {
    public int id;
    public String dir;
    public int enf_mode, rep_mode;
    public int reserved, utilized;

    RK_resource_set(int i) 
    {
	id = i;
	// make a string of /proc/rk/<id> where id is hex
	dir = "/proc/rk/"+Integer.toHexString(id);
	System.out.println("RK_resource_set: "+dir);
    }

    void readStatus()
	throws IOException
    {
	DataInputStream in;
	// open "/proc/rk/<id>/cpu"
	in = new DataInputStream(new FileInputStream(dir+"/cpu.raw"));
	enf_mode = in.readInt();
	rep_mode = in.readInt();
	reserved = in.readInt();
	utilized = in.readInt();
	// close
	in.close();
    }
}

